#!/usr/bin/python
import sys, os, SocketServer, BaseHTTPServer, CGIHTTPServer, socket, time

class ThreadingCGIServer(SocketServer.ThreadingMixIn, BaseHTTPServer.HTTPServer):
    pass
try:
  os.chdir(os.path.dirname(__file__))
except:
  pass

version="1.0"

print " _____________________"
print "| UliHTTP Server "+version+"  | "
print "|_____________________| "
print ""
print ""
print """Copyright (c) 2011, Ulrich Schmidt 
All rights reserved. 

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met: 

 * Redistributions of source code must retain the above copyright notice, 
   this list of conditions and the following disclaimer. 
 * Redistributions in binary form must reproduce the above copyright 
   notice, this list of conditions and the following disclaimer in the 
   documentation and/or other materials provided with the distribution. 
 * Neither the name of Ulrich Schmidt nor the names of its contributors may 
   be used to endorse or promote products derived from this software 
   without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
POSSIBILITY OF SUCH DAMAGE. 


"""
print ""


print "Konfiguration"
print "_________________________________________"

print ""


try:
  port=raw_input("Auf welchem Port soll der Server lauschen? [80]: ")
except KeyboardInterrupt:
  port="80"

try:
  port=int(port)
except:
  port=80


os.chdir("www")

DefaultDocumentRoot=os.getcwd()

try:
  DocumentRoot=raw_input("Wurzelverzeichnis des Servers ["+DefaultDocumentRoot+"]: ")
except KeyboardInterrupt:
  DocumentRoot=DefaultDocumentRoot 




if DocumentRoot=="":
  DocumentRoot=DefaultDocumentRoot


try:
  os.chdir(DocumentRoot)
except OSError, e:
  print e
  sys.exit()

os.environ["DOCUMENT_ROOT"]=os.getcwd()


Handler=CGIHTTPServer.CGIHTTPRequestHandler
Handler.cgi_directories=['/cgi-bin']


Handler.server_version="UliHTTP Server "+version
Handler.sys_version=""


try:
  httpd = ThreadingCGIServer(('',port), Handler)
  print "Server gestartet"
except Exception, e:
  print e
  sys.exit()

try:
  httpd.serve_forever()
except:
  print "Server gestoppt"
  sys.exit()
